package org.apache.bcel.generic;

import org.apache.bcel.ExceptionConst;
import org.apache.bcel.ExceptionConst.EXCS;

public class NEW extends CPInstruction implements LoadClass, AllocationInstruction, ExceptionThrower, StackProducer {
   NEW() {
   }

   public NEW(int index) {
      super((short)187, index);
   }

   public void accept(Visitor v) {
      v.visitLoadClass(this);
      v.visitAllocationInstruction(this);
      v.visitExceptionThrower(this);
      v.visitStackProducer(this);
      v.visitTypedInstruction(this);
      v.visitCPInstruction(this);
      v.visitNEW(this);
   }

   public Class<?>[] getExceptions() {
      return ExceptionConst.createExceptions(EXCS.EXCS_CLASS_AND_INTERFACE_RESOLUTION, new Class[]{ExceptionConst.ILLEGAL_ACCESS_ERROR, ExceptionConst.INSTANTIATION_ERROR});
   }

   public ObjectType getLoadClassType(ConstantPoolGen cpg) {
      return (ObjectType)this.getType(cpg);
   }
}
